diff -uNrd ircd-hybrid-6.3.1.dist/src/.depend ircd-hybrid-6.3.1/src/.depend
--- ircd-hybrid-6.3.1.dist/src/.depend	Thu Dec  6 23:13:29 2001
+++ ircd-hybrid-6.3.1/src/.depend	Sat May  3 10:22:15 2003
@@ -30,8 +30,8 @@
  ../include/numeric.h ../include/res.h ../include/fileio.h \
  ../include/../adns/adns.h ../include/s_bsd.h ../include/s_conf.h \
  ../include/motd.h ../include/s_log.h ../include/s_misc.h \
- ../include/s_serv.h ../include/send.h ../include/struct.h \
- ../include/whowas.h ../include/s_debug.h
+ ../include/s_serv.h ../include/s_stats.h ../include/send.h \
+ ../include/struct.h ../include/whowas.h ../include/s_debug.h
 dbuf.o: dbuf.c ../include/dbuf.h ../include/config.h \
  ../include/setup.h ../include/common.h ../include/irc_string.h \
  ../include/ircd_defs.h
@@ -126,10 +126,29 @@
  ../include/numeric.h ../include/s_bsd.h ../include/res.h \
  ../include/fileio.h ../include/../adns/adns.h ../include/s_log.h \
  ../include/send.h
+m_encap.o: m_encap.c ../include/ircd.h ../include/config.h \
+ ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+ ../include/dbuf.h ../include/send.h ../include/s_conf.h \
+ ../include/fileio.h ../include/motd.h ../include/s_serv.h \
+ ../include/m_commands.h
 m_error.o: m_error.c ../include/m_commands.h ../include/config.h \
  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
  ../include/dbuf.h ../include/common.h ../include/ircd.h \
- ../include/numeric.h ../include/send.h ../include/s_debug.h
+ ../include/numeric.h ../include/send.h ../include/s_debug.h \
+ ../include/s_log.h
+m_etrace.o: m_etrace.c ../include/m_commands.h ../include/config.h \
+ ../include/setup.h ../include/class.h ../include/client.h \
+ ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
+ ../include/hash.h ../include/irc_string.h ../include/ircd.h \
+ ../include/numeric.h ../include/s_bsd.h ../include/res.h \
+ ../include/fileio.h ../include/../adns/adns.h ../include/s_serv.h \
+ ../include/send.h
+m_flags.o: m_flags.c ../include/m_commands.h ../include/config.h \
+ ../include/setup.h ../include/s_user.h ../include/client.h \
+ ../include/ircd_defs.h ../include/dbuf.h ../include/common.h \
+ ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
+ ../include/s_serv.h ../include/send.h ../include/struct.h \
+ ../include/m_flags.h
 m_gline.o: m_gline.c ../include/m_commands.h ../include/config.h \
  ../include/setup.h ../include/m_gline.h ../include/ircd_defs.h \
  ../include/channel.h ../include/client.h ../include/dbuf.h \
@@ -169,7 +188,8 @@
  ../include/irc_string.h ../include/ircd.h ../include/mtrie_conf.h \
  ../include/numeric.h ../include/s_conf.h ../include/fileio.h \
  ../include/motd.h ../include/s_log.h ../include/s_misc.h \
- ../include/send.h ../include/struct.h ../include/hash.h
+ ../include/s_serv.h ../include/send.h ../include/struct.h \
+ ../include/hash.h
 m_links.o: m_links.c ../include/m_commands.h ../include/config.h \
  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
  ../include/dbuf.h ../include/irc_string.h ../include/ircd.h \
@@ -196,6 +216,11 @@
  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
  ../include/s_serv.h ../include/s_user.h ../include/send.h
+m_map.o: m_map.c ../include/ircd.h ../include/config.h \
+ ../include/setup.h ../include/client.h ../include/ircd_defs.h \
+ ../include/dbuf.h ../include/numeric.h ../include/send.h \
+ ../include/s_conf.h ../include/fileio.h ../include/motd.h \
+ ../include/m_commands.h
 m_message.o: m_message.c ../include/m_commands.h ../include/config.h \
  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
  ../include/dbuf.h ../include/flud.h ../include/ircd.h \
@@ -228,7 +253,8 @@
 m_pong.o: m_pong.c ../include/m_commands.h ../include/config.h \
  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
- ../include/send.h ../include/channel.h ../include/irc_string.h
+ ../include/send.h ../include/channel.h ../include/s_stats.h \
+ ../include/irc_string.h
 m_quit.o: m_quit.c ../include/m_commands.h ../include/config.h \
  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
@@ -298,7 +324,8 @@
  ../include/dline_conf.h ../include/fileio.h ../include/irc_string.h \
  ../include/ircd.h ../include/mtrie_conf.h ../include/numeric.h \
  ../include/s_conf.h ../include/motd.h ../include/s_log.h \
- ../include/s_misc.h ../include/send.h ../include/struct.h
+ ../include/s_misc.h ../include/s_serv.h ../include/send.h \
+ ../include/struct.h
 m_userhost.o: m_userhost.c ../include/m_commands.h ../include/config.h \
  ../include/setup.h ../include/client.h ../include/ircd_defs.h \
  ../include/dbuf.h ../include/ircd.h ../include/numeric.h \
@@ -399,13 +426,13 @@
 s_log.o: s_log.c ../include/s_log.h ../include/irc_string.h \
  ../include/ircd_defs.h ../include/config.h ../include/setup.h \
  ../include/ircd.h ../include/s_misc.h
-s_misc.o: s_misc.c ../include/s_misc.h ../include/client.h \
+s_misc.o: s_misc.c ../include/s_misc.h ../include/channel.h \
  ../include/config.h ../include/setup.h ../include/ircd_defs.h \
- ../include/dbuf.h ../include/common.h ../include/irc_string.h \
- ../include/ircd.h ../include/numeric.h ../include/res.h \
- ../include/fileio.h ../include/../adns/adns.h ../include/s_bsd.h \
- ../include/s_conf.h ../include/motd.h ../include/s_serv.h \
- ../include/send.h ../include/struct.h
+ ../include/client.h ../include/dbuf.h ../include/common.h \
+ ../include/irc_string.h ../include/ircd.h ../include/numeric.h \
+ ../include/res.h ../include/fileio.h ../include/../adns/adns.h \
+ ../include/s_bsd.h ../include/s_conf.h ../include/motd.h \
+ ../include/s_serv.h ../include/send.h ../include/struct.h
 s_serv.o: s_serv.c ../include/s_serv.h ../include/config.h \
  ../include/setup.h ../include/channel.h ../include/ircd_defs.h \
  ../include/class.h ../include/client.h ../include/dbuf.h \
@@ -431,7 +458,8 @@
  ../include/s_bsd.h ../include/res.h ../include/fileio.h \
  ../include/../adns/adns.h ../include/s_conf.h ../include/s_log.h \
  ../include/s_serv.h ../include/s_stats.h ../include/scache.h \
- ../include/send.h ../include/struct.h ../include/whowas.h
+ ../include/send.h ../include/struct.h ../include/whowas.h \
+ ../include/m_flags.h
 s_zip.o: s_zip.c ../include/client.h ../include/config.h \
  ../include/setup.h ../include/ircd_defs.h ../include/dbuf.h \
  ../include/s_zip.h ../include/irc_string.h ../include/packet.h \
diff -uNrd ircd-hybrid-6.3.1.dist/src/adns.c ircd-hybrid-6.3.1/src/adns.c
--- ircd-hybrid-6.3.1.dist/src/adns.c	Mon Mar  4 18:07:24 2002
+++ ircd-hybrid-6.3.1/src/adns.c	Sat Apr 19 21:13:48 2003
@@ -167,28 +167,28 @@
 	dns_do_callbacks();
 	timeout_adns();
 }
-/* void adns_gethost(const char *name, struct DNSQuery *req);
+/* int adns_gethost(const char *name, struct DNSQuery *req);
  * Input: A name, an address family, a DNSQuery structure.
  * Output: None
  * Side effects: Sets up a query structure and sends off a DNS query to
  *               the DNS server to resolve an "A"(address) entry by name.
  */
-void adns_gethost(const char *name, struct DNSQuery *req)
+int adns_gethost(const char *name, struct DNSQuery *req)
 {
  assert(dns_state->nservers > 0);
- adns_submit(dns_state, name, adns_r_addr, adns_qf_owner, req,
-             &req->query);
+ return(adns_submit(dns_state, name, adns_r_addr, adns_qf_owner, req,
+             &req->query));
 
 }
 
-/* void adns_getaddr(struct irc_inaddr *addr, int aftype,
+/* int adns_getaddr(struct irc_inaddr *addr, int aftype,
                      struct DNSQuery *req);
  * Input: An address, an address family, a DNSQuery structure.
  * Output: None
  * Side effects: Sets up a query entry and sends it to the DNS server to
  *               resolve an IP address to a domain name.
  */
-void adns_getaddr(struct in_addr *addr,
+int adns_getaddr(struct in_addr *addr,
                   struct DNSQuery *req)
 {
  struct sockaddr_in ipn;
@@ -196,6 +196,6 @@
   ipn.sin_family = AF_INET;
   ipn.sin_port = 0;
   ipn.sin_addr.s_addr = addr->s_addr;
-  adns_submit_reverse(dns_state, (struct sockaddr *)&ipn,
-                      adns_r_ptr, adns_qf_owner|adns_qf_cname_loose|adns_qf_quoteok_anshost, req, &req->query);
+  return(adns_submit_reverse(dns_state, (struct sockaddr *)&ipn,
+                      adns_r_ptr, adns_qf_owner|adns_qf_cname_loose|adns_qf_quoteok_anshost, req, &req->query));
 }
diff -uNrd ircd-hybrid-6.3.1.dist/src/channel.c ircd-hybrid-6.3.1/src/channel.c
--- ircd-hybrid-6.3.1.dist/src/channel.c	Sun Feb 17 00:58:12 2002
+++ ircd-hybrid-6.3.1/src/channel.c	Fri May  2 18:21:21 2003
@@ -22,7 +22,7 @@
  * These flags can be set in a define if you wish.
  *
  *
- * $Id: channel.c,v 1.233 2002/02/17 05:58:12 lusky Exp $
+ * $Id: channel.c,v 1.234 2002/08/02 21:57:50 androsyn Exp $
  */
 #include "channel.h"
 #include "m_commands.h"
@@ -77,7 +77,11 @@
 static void change_chan_flag(struct Channel *, struct Client *, int );
 static void set_deopped(struct Client *,struct Channel *,int);
 
+#ifdef PART_MESSAGES
+static  char    *PartFmt = ":%s PART %s :%s";
+#else
 static  char    *PartFmt = ":%s PART %s";
+#endif
 /*
  * some buffers for rebuilding channel/nick lists with ,'s
  */
@@ -616,7 +620,11 @@
   Link  *lp;
 
 #ifdef JUPE_CHANNEL
+#ifdef JUPE_BYPASS
+  if (MyClient(cptr) && chptr->juped && !IsAnOper(cptr))
+#else
   if (MyClient(cptr) && chptr->juped)
+#endif
     {
       return 1;
     }
@@ -631,6 +639,12 @@
   if (chptr->mode.mode & MODE_NOPRIVMSGS && !lp)
     return (MODE_NOPRIVMSGS);
 
+#ifdef SILENCE_ON_BAN
+  if (is_banned(cptr, chptr) == CHFL_BAN &&
+      (!lp || !(lp->flags & (CHFL_CHANOP|CHFL_VOICE))))
+    return (MODE_MODERATED);
+#endif
+
   return 0;
 }
 
@@ -652,6 +666,11 @@
 void channel_modes(struct Client *cptr, char *mbuf, char *pbuf, struct Channel *chptr)
 {
   *mbuf++ = '+';
+
+#ifdef SHOW_JUPE_MODE
+  if (chptr->juped == 1)
+    *mbuf++ = 'j';
+#endif
   if (chptr->mode.mode & MODE_SECRET)
     *mbuf++ = 's';
 
@@ -987,6 +1006,10 @@
   char  *pbufw_new = parabuf_new;
 
   int   ischop;
+#ifdef LOCAL_HACKOPS
+  int   isok1;
+  int   isloc;
+#endif
   int   isok;
   int   isdeop;
   int   chan_op;
@@ -1001,8 +1024,19 @@
   /* is client marked as deopped */
   isdeop = !ischop && !IsServer(sptr) && (user_mode_chan & CHFL_DEOPPED);
 
+#ifdef LOCAL_HACKOPS
+  /* is an op or server or remote user on a TS channel */
+  isok1 = ischop || (!isdeop && IsServer(cptr) && chptr->channelts);
+
+  /* it's a local channel and the user is an oper */
+  isloc = (chptr->chname[0] == '&') && IsAnOper(sptr);
+
+  /* The union of the above is the final "ok" check */
+  isok = isok1 || isloc;
+#else
   /* is an op or server or remote user on a TS channel */
   isok = ischop || (!isdeop && IsServer(cptr) && chptr->channelts);
+#endif
 
   /* isok_c calculated later, only if needed */
 
@@ -1115,7 +1149,14 @@
 
           if ((who == sptr) && (c == 'o'))
             {
+#ifdef LOCAL_HACKOPS
+              /* If you're trying to op yourself and it's NOT a local channel
+               * with an operator source
+               */
+              if((whatt == MODE_ADD) && !isloc)
+#else
               if(whatt == MODE_ADD)
+#endif
                 break;
 	    }
 
@@ -1899,9 +1940,13 @@
   int ban_or_exception;
 
 #ifdef JUPE_CHANNEL
+#ifdef JUPE_BYPASS
+  if(chptr->juped && !IsAnOper(sptr))
+#else
   if(chptr->juped)
+#endif
     {
-      sendto_ops_flags(FLAGS_SPY,
+      sendto_ops_flags(FLAGS_JUPE,
              "User %s (%s@%s) is attempting to join locally juped channel %s",
                      sptr->name,
                      sptr->username, sptr->host,chptr->chname);
@@ -2304,7 +2349,11 @@
             {
               chptr = lp->value.chptr;
               sendto_channel_butserv(chptr, sptr, PartFmt,
+#ifdef PART_MESSAGES
+                                     parv[0], chptr->chname, "");
+#else
                                      parv[0], chptr->chname);
+#endif
               remove_user_from_channel(sptr, chptr, 0);
             }
 
@@ -2634,9 +2683,17 @@
       **  Remove user from the old channel (if any)
       */
             
+#ifdef PART_MESSAGES
+      sendto_match_servs(chptr, cptr, PartFmt, parv[0], name,
+                         (parc == 3) ? parv[2] : "");
+
+      sendto_channel_butserv(chptr, sptr, PartFmt, parv[0], name,
+                             (parc == 3) ? parv[2] : "");
+#else
       sendto_match_servs(chptr, cptr, PartFmt, parv[0], name);
             
       sendto_channel_butserv(chptr, sptr, PartFmt, parv[0], name);
+#endif
       remove_user_from_channel(sptr, chptr, 0);
       name = strtoken(&p, (char *)NULL, ",");
     }
@@ -2861,8 +2918,8 @@
     knock_local = 1;
 #else
   {
-    sendto_one(sptr, form_str(ERR_UNKNOWNCOMMAND),
-               me.name, sptr->name, "knock");
+    sendto_one(sptr, form_str(ERR_KNOCKDISABLED),
+               me.name, sptr->name);
     return 0;
   }
 #endif
@@ -2898,13 +2955,17 @@
        ))
     {
       if(knock_local)
-        sendto_one(sptr,":%s NOTICE %s :*** Notice -- Channel is open!",
-                   me.name, sptr->name);
+        sendto_one(sptr, form_str(ERR_CHANOPEN), me.name, sptr->name,
+                   name);
       return 0;
     }
 
-  /* don't allow a knock if the user is banned, or the channel is secret */
-  if (knock_local && ((chptr->mode.mode & MODE_SECRET) || 
+  /* don't allow a knock if the user is banned, or the channel is private */
+#ifdef OLD_KNOCK
+  if (knock_local && ((chptr->mode.mode & MODE_SECRET) ||
+#else
+  if (knock_local && ((chptr->mode.mode & MODE_PRIVATE) || 
+#endif
       (is_banned(sptr, chptr) == CHFL_BAN)) )
     {
       sendto_one(sptr, form_str(ERR_CANNOTSENDTOCHAN), me.name, parv[0],
@@ -2916,9 +2977,8 @@
   if (IsMember(sptr, chptr))
     {
       if(knock_local)
-        sendto_one(sptr,":%s NOTICE %s :*** Notice -- You are on channel already!",
-                   me.name,
-                   sptr->name);
+        sendto_one(sptr, form_str(ERR_KNOCKONCHAN), me.name, sptr->name,
+                   name);
       return 0;
     }
 
@@ -2944,27 +3004,21 @@
   
     if((sptr->last_knock + KNOCK_DELAY) > CurrentTime)
     {
-      sendto_one(sptr,":%s NOTICE %s :*** Notice -- Wait %d seconds before another knock",
-                 me.name,
-                 sptr->name,
-                 KNOCK_DELAY - (CurrentTime - sptr->last_knock));
+      sendto_one(sptr, form_str(ERR_TOOMANYKNOCK), me.name, sptr->name,
+                 name, "user");
       return 0;
     }
 
     if((chptr->last_knock + KNOCK_DELAY_CHANNEL) > CurrentTime)
     {
-      sendto_one(sptr, ":%s NOTICE %s :*** Notice -- Wait %d seconds before another knock to %s",
-                 me.name, sptr->name,
-		 KNOCK_DELAY_CHANNEL - (CurrentTime - chptr->last_knock),
-		 name);
+      sendto_one(sptr, form_str(ERR_TOOMANYKNOCK), me.name, sptr->name,
+                 name, "channel");
       return 0;
     }
 
     sptr->last_knock = CurrentTime;
 
-    sendto_one(sptr,":%s NOTICE %s :*** Notice -- Your KNOCK has been delivered",
-                 me.name,
-                 sptr->name);
+    sendto_one(sptr, form_str(RPL_KNOCKDLVR), me.name, sptr->name, name);
   }
   
   chptr->last_knock = CurrentTime;
@@ -2980,20 +3034,11 @@
    * -Dianora
    */
 
+  /* bit of paranoid, be a shame if it cored for this -Dianora */
+  if(sptr->user)
   {
-    char message[NICKLEN*2+CHANNELLEN+USERLEN+HOSTLEN+30];
-
-    /* bit of paranoid, be a shame if it cored for this -Dianora */
-    if(sptr->user)
-    {
-      ircsprintf(message,"KNOCK: %s (%s [%s@%s] has asked for an invite)",
-                   chptr->chname,
-                   sptr->name,
-                   sptr->username,
-                   sptr->host);
-      send_knock(sptr, cptr, chptr, MODE_CHANOP, message,
-                 (parc > 3) ? parv[3] : "");
-    }
+    send_knock(sptr, cptr, chptr, MODE_CHANOP, name,
+               (parc > 3) ? parv[3] : "");
   }
 
 #endif
@@ -3074,7 +3119,12 @@
                * XXX - this truncates the topic_nick if
                * strlen(sptr->name) > NICKLEN
                */
+#ifdef TOPIC_UH
+              ircsprintf(chptr->topic_nick, "%s!%s@%s", sptr->name,
+                         sptr->username, sptr->host);
+#else
               strncpy_irc(chptr->topic_nick, sptr->name, NICKLEN);
+#endif /* TOPIC_UH */
               chptr->topic_time = CurrentTime;
 #endif
               sendto_match_servs(chptr, cptr,":%s TOPIC %s :%s",
diff -uNrd ircd-hybrid-6.3.1.dist/src/client.c ircd-hybrid-6.3.1/src/client.c
--- ircd-hybrid-6.3.1.dist/src/client.c	Sun Feb 17 00:58:13 2002
+++ ircd-hybrid-6.3.1/src/client.c	Sat Apr 19 21:06:45 2003
@@ -42,6 +42,7 @@
 #include "s_log.h"
 #include "s_misc.h"
 #include "s_serv.h"
+#include "s_stats.h"
 #include "send.h"
 #include "struct.h"
 #include "whowas.h"
@@ -364,6 +365,39 @@
 #endif
                   continue;         /* and go examine next fd/cptr */
                 }
+	      else if((aconf = find_tdline(ntohl(cptr->ip.s_addr))))
+	      {
+		  sendto_realops("D-line active for %s", get_client_name(cptr, FALSE));
+
+		  dying_clients[die_index] = cptr;
+
+
+#if defined(KLINE_WITH_CONNECTION_CLOSED) && defined(KLINE_WITH_REASON)
+		  dying_clients_reason[die_index++] = "Connection closed";
+		  reason = aconf->passwd ? aconf->passwd :"D-lined";
+#else
+#ifdef KLINE_WITH_CONNECTION_CLOSED
+		  reason = "Connection closed";
+		  dying_clients_reason[die_index++] = reason;
+#else
+#ifdef KLINE_WITH_REASON
+		  reason = aconf->passwd ? aconf->passwd : "D-lined";
+		  dying_clients_reason[die_index++] = reason;
+#else
+		  reason = "D-lined";
+		  dying_clients_reason[die_index++] = reason;
+#endif
+#endif
+#endif
+		  dying_clients[die_index] = (struct Client *)NULL;
+		  if(IsPerson(cptr))
+		      sendto_one(cptr, form_str(ERR_YOUREBANNEDCREEP),
+				 me.name, cptr->name, reason);
+		  else
+		      sendto_one(cptr, "NOTICE DLINE :*** You have been D-lined");
+
+		  continue;
+	      }
             }
           else
             {
@@ -541,6 +575,10 @@
                   sendto_ops("No response from %s, closing link",
                              get_client_name(cptr, MASK_IP));
                 }
+#ifdef ANTI_IP_SPOOF
+               if (!IsRegistered(cptr) && (cptr->name[0]) && (cptr->user))
+                 ServerStats->is_ipspoof++;
+#endif
               /*
                * this is used for KILL lines with time restrictions
                * on them - send a messgae to the user being killed
@@ -1173,7 +1211,10 @@
         ts_warn("server %s without servptr!", sptr->name);
     }
   else if (sptr->servptr && sptr->servptr->serv)
+    {
       del_client_from_llist(&(sptr->servptr->serv->users), sptr);
+      sptr->servptr->serv->usercnt--;
+    }
   /* there are clients w/o a servptr: unregistered ones */
 
   /*
@@ -1423,6 +1464,12 @@
 #endif
       if (IsAnOper(sptr))
         {
+
+#ifdef DEOPER_NOTICE
+          sendto_realops_flags(FLAGS_SPY,
+            "operator %s has exited", sptr->name);
+#endif
+
           fdlist_delete(sptr->fd, FDL_OPER | FDL_BUSY);
           /* LINKLIST */
           /* oh for in-line functions... */
diff -uNrd ircd-hybrid-6.3.1.dist/src/dline_conf.c ircd-hybrid-6.3.1/src/dline_conf.c
--- ircd-hybrid-6.3.1.dist/src/dline_conf.c	Fri Dec 14 11:56:36 2001
+++ ircd-hybrid-6.3.1/src/dline_conf.c	Sat Apr 19 21:06:45 2003
@@ -828,9 +828,9 @@
 
       c = 'D';
       if(scan->flags & CONF_FLAGS_E_LINED)
-        c = 'd';
-      /* print Dline */
+        c = 'E';
 
+      /* print Dline */
       get_printable_conf(scan, &name, &host, &pass, &user, &port);
 
       sendto_one(sptr, form_str(RPL_STATSDLINE), me.name,
diff -uNrd ircd-hybrid-6.3.1.dist/src/irc_string.c ircd-hybrid-6.3.1/src/irc_string.c
--- ircd-hybrid-6.3.1.dist/src/irc_string.c	Sun Dec  9 21:56:28 2001
+++ ircd-hybrid-6.3.1/src/irc_string.c	Fri May  2 11:35:06 2003
@@ -36,15 +36,16 @@
  *
  *
  * Thu Nov 24 18:22:48 1986 
+ *
+ * Localisation of times, 12 fév 2002 -Hwy
  */
 const char* myctime(time_t value)
 {
   static char buf[32];
-  char*       p;
+  struct tm *ltm = localtime(&value);
+  static char *gcc_sucks = "%c";
 
-  strcpy(buf, ctime(&value));
-  if ((p = strchr(buf, '\n')) != NULL)
-    *p = '\0';
+  strftime(buf, 32, gcc_sucks, ltm);
   return buf;
 }
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/ircd.c ircd-hybrid-6.3.1/src/ircd.c
--- ircd-hybrid-6.3.1.dist/src/ircd.c	Tue Feb  5 23:56:12 2002
+++ ircd-hybrid-6.3.1/src/ircd.c	Sat Apr 19 21:06:45 2003
@@ -74,6 +74,10 @@
 #include <getopt.h>
 #endif /* HAVE_GETOPT_H */
 
+#if defined(HAVE_LOCALE_H)
+#include <locale.h>
+#endif /* HAVE_LOCALE_H */
+
 /*
  * for getopt
  * ZZZ this is going to need confirmation on other OS's
@@ -150,6 +154,7 @@
 
 char**  myargv;
 int     dorehash   = 0;
+int     doremotd   = 0;
 int     debuglevel = -1;        /* Server debug level */
 char*   debugmode  = "";        /*  -"-    -"-   -"-  */
 
@@ -530,6 +535,13 @@
       rehash(&me, &me, 1);
       dorehash = 0;
     }
+  if (doremotd)
+    {
+       ReadMessageFile( &ConfigFileEntry.motd );
+       sendto_realops("Got signal SIGUSR1, reloading ircd motd file");
+       doremotd = 0;
+    }
+
   /*
   ** Flush output buffers on all connections now if they
   ** have data in them (or at least try to flush)
@@ -594,6 +606,17 @@
  server_split_time = CurrentTime;
 #endif
 
+#ifdef CHECK_CLONE
+  GlobalSetOptions.clone_num = CHECK_CLONE_LIMIT;
+  GlobalSetOptions.clone_period = CHECK_CLONE_PERIOD;
+#endif
+
+  MAXTKTIME = DEFAULT_MAXTKTIME;
+
+#ifdef XLINE_COMMAND
+  GlobalSetOptions.xlinetype = DEFAULT_XLINETYPE;
+#endif
+
  /* End of global set options */
 
 }
@@ -702,10 +725,33 @@
 #endif /* RLIMIT_CORE */
 }
 
+#ifdef SAVE_MAXCLIENT
+void write_stats(void)
+{
+  int fd;
+  char buff[20];
+  if ((fd = open(MXPATH, O_CREAT|O_WRONLY, 0600))>=0)
+    {
+      ircsprintf(buff,"%d\n%d\n", Count.max_loc, Count.max_tot);
+      if (write(fd, buff, strlen(buff)) == -1)
+        log(L_ERROR,"Error writing to max clients file %s", MXPATH);
+      close(fd);
+      return;
+    }
+  else
+    log(L_ERROR, "Error opening max clients file %s", MXPATH);
+}
+#endif /* SAVE_MAXCLIENT */
+
 int main(int argc, char *argv[])
 {
   time_t      delay = 0;
   aConfItem*  aconf;
+#ifdef SAVE_MAXCLIENT
+  FBFILE* file;
+  char mline[20];
+  int m1;
+#endif
   
   if(geteuid() == 0)
   {
@@ -723,6 +769,17 @@
     }
 
   /*
+   * Setup the locale settings for times
+   * It will use the default language setting for the user that starts
+   * ircd.  Set the LC_TIME or LANG variables in your environment prior
+   * to starting the daemon in order to change the server's language.
+   * -Hwy
+   */
+#ifdef USE_SETLOCALE
+  (void) setlocale(LC_TIME, "");
+#endif
+
+  /*
    * Setup corefile size immediately after boot
    */
   setup_corefile();
@@ -841,6 +898,22 @@
   
   check_class();
   write_pidfile();
+
+#ifdef SAVE_MAXCLIENT
+  if ((file = fbopen(MXPATH, "r")))
+    {
+      if (fbgets(mline, sizeof(mline), file))
+        {
+          m1 = atoi(mline);
+          if (fbgets(mline, sizeof(mline), file))
+            {
+              Count.max_loc = m1;
+              Count.max_tot = atoi(mline);
+            }
+        }
+      fbclose(file);
+    }
+#endif
 
   log(L_NOTICE, "Server Ready");
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/ircd_signal.c ircd-hybrid-6.3.1/src/ircd_signal.c
--- ircd-hybrid-6.3.1.dist/src/ircd_signal.c	Mon Apr 15 19:13:02 2002
+++ ircd-hybrid-6.3.1/src/ircd_signal.c	Sat Apr 19 21:06:45 2003
@@ -43,6 +43,9 @@
 static void sigterm_handler(int sig)  
 {
   flush_connections(0);
+#ifdef SAVE_MAXCLIENT
+  write_stats();
+#endif
   log(L_CRIT, "Server killed By SIGTERM");
   exit(-1);
 }
@@ -56,6 +59,14 @@
 }
 
 /*
+ * sigusr1_handler - reread the motd file
+ */
+static void sigusr1_handler(int sig)
+{
+  doremotd = 1;
+}
+
+/*
  * sigint_handler - restart the server
  */
 static void sigint_handler(int sig)
@@ -105,6 +116,10 @@
   act.sa_handler = sigterm_handler;
   sigaddset(&act.sa_mask, SIGTERM);
   sigaction(SIGTERM, &act, 0);
+
+  act.sa_handler = sigusr1_handler;
+  sigaddset(&act.sa_mask, SIGUSR1);
+  sigaction(SIGUSR1, &act, 0);
 }
 
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_away.c ircd-hybrid-6.3.1/src/m_away.c
--- ircd-hybrid-6.3.1.dist/src/m_away.c	Sat Dec  8 02:06:13 2001
+++ ircd-hybrid-6.3.1/src/m_away.c	Sat Apr 19 21:06:45 2003
@@ -136,6 +136,10 @@
    unnecessary traffic. *sigh* so... as comstud has done, I've
    commented out this sendto_serv_butone() call -Dianora */
 /*      sendto_serv_butone(cptr, ":%s AWAY", parv[0]); */
+#ifdef PROPAGATE_AWAY
+      /* Optionally enabled in +fr -Hwy */
+      sendto_serv_butone(cptr, ":%s AWAY", parv[0]);
+#endif
       if (MyConnect(sptr))
         sendto_one(sptr, form_str(RPL_UNAWAY),
                    me.name, parv[0]);
@@ -150,6 +154,10 @@
    unnecessary traffic. *sigh* so... as comstud has done, I've
    commented out this sendto_serv_butone() call -Dianora */
 /*  sendto_serv_butone(cptr, ":%s AWAY :%s", parv[0], awy2); */
+#ifdef PROPAGATE_AWAY
+  /* Optionally renabled for +fr -Hwy */
+  sendto_serv_butone(cptr, ":%s AWAY :%s", parv[0], awy2);
+#endif
 
   /* don't use realloc() -Dianora */
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_close.c ircd-hybrid-6.3.1/src/m_close.c
--- ircd-hybrid-6.3.1.dist/src/m_close.c	Fri Jul 30 00:01:32 1999
+++ ircd-hybrid-6.3.1/src/m_close.c	Sat Apr 19 21:06:45 2003
@@ -116,6 +116,8 @@
       closed++;
     }
   sendto_one(sptr, form_str(RPL_CLOSEEND), me.name, parv[0], closed);
+  sendto_realops("%s issued CLOSE, %d connection%s closed", sptr->name,
+                 closed, (closed == 1) ? "" : "s");
   return 0;
 }
 
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_connect.c ircd-hybrid-6.3.1/src/m_connect.c
--- ircd-hybrid-6.3.1.dist/src/m_connect.c	Mon Dec  3 23:47:45 2001
+++ ircd-hybrid-6.3.1/src/m_connect.c	Sat Apr 19 21:06:45 2003
@@ -175,19 +175,33 @@
   tmpport = port = aconf->port;
   if (parc > 2 && !EmptyString(parv[2]))
     {
+#ifdef NEG_PORT
+      if ((port = atoi(parv[2])) < 0)
+#else
       if ((port = atoi(parv[2])) <= 0)
+#endif
         {
           sendto_one(sptr, "NOTICE %s :Connect: Illegal port number",
                      parv[0]);
           return 0;
         }
     }
+#ifdef NEG_PORT
+  else if (port < 0 && (port = PORTNUM) <= 0)
+#else
   else if (port <= 0 && (port = PORTNUM) <= 0)
+#endif
     {
       sendto_one(sptr, ":%s NOTICE %s :Connect: missing port number",
                  me.name, parv[0]);
       return 0;
     }
+#ifdef NEG_PORT
+  if (port == 0)
+    port = tmpport; /* From conf */
+  if (port == 0)
+    port = PORTNUM; /* Default if there wasn't one set in conf */
+#endif
   /*
    * Notify all operators about remote connect requests
    */
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_die.c ircd-hybrid-6.3.1/src/m_die.c
--- ircd-hybrid-6.3.1.dist/src/m_die.c	Sat Dec  8 02:06:13 2001
+++ ircd-hybrid-6.3.1/src/m_die.c	Sat Apr 19 21:06:45 2003
@@ -147,6 +147,9 @@
                    me.name, get_client_name(sptr, MASK_IP));
     }
   flush_connections(0);
+#ifdef SAVE_MAXCLIENT
+  write_stats();
+#endif
   log(L_NOTICE, "Server terminated by %s", get_client_name(sptr, HIDE_IP));
   /* 
    * this is a normal exit, tell the os it's ok 
diff -uNrd ircd-hybrid-6.3.1.dist/src/m_encap.c ircd-hybrid-6.3.1/src/m_encap.c
--- ircd-hybrid-6.3.1.dist/src/m_encap.c	Wed Dec 31 19:00:00 1969
+++ ircd-hybrid-6.3.1/src/m_encap.c	Thu May  8 12:50:18 2003
@@ -0,0 +1,93 @@
+/*  src/m_encap.c
+ *  Copyright (C) 2003 ircd-ratbox development team
+ *  Port to Hybrid 6 Copyright (C) 2003 W. Jami Campbell, patch maintainer
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions are
+ * met:
+ *
+ * 1.Redistributions of source code must retain the above copyright notice,
+ *   this list of conditions and the following disclaimer.
+ * 2.Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * 3.The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+ * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
+ * DISCLAIMED. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
+ * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
+ * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
+ * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
+ * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING
+ * IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+ * POSSIBILITY OF SUCH DAMAGE.
+ *
+ * $Id: m_encap.c,v 1.3 2003/03/12 00:16:11 leeh Exp $
+ */
+
+#include "ircd.h"
+#include "config.h"
+#include "client.h"
+#include "send.h"
+#include "s_conf.h"
+#include "s_serv.h"
+#include "m_commands.h"
+#include <stdio.h>
+#include <string.h>
+
+int m_encap(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
+{
+  char buffer[BUFSIZE];
+  char *ptr;
+  int cur_len = 0;
+  int len;
+  int i;
+
+  if (!IsServer(cptr))
+    return 0;
+
+#if 0
+  if (match(parv[1], me.name))
+  {
+    /* This matches us, process the subcommand and its arguments */
+
+    /* Be sure to propagate it on...so no return. */
+  }
+#endif
+
+  ptr = buffer;
+
+  for(i = 1; i < parc - 1; i++)
+  {
+    len = strlen(parv[i]) + 1;
+
+    /* ugh, not even at the last parameter, just bail --fl */
+    if((cur_len + len) >= sizeof(buffer))
+      return 0;
+
+    snprintf(ptr, sizeof(buffer) - cur_len, "%s ", parv[i]);
+    cur_len += len;
+    ptr += len;
+  }
+
+  len = strlen(parv[i]);
+
+  /* if its a command without parameters, dont prepend a ':' */
+  if(parc == 3)
+    snprintf(ptr, sizeof(buffer) - cur_len, "%s", parv[2]);
+  else
+    snprintf(ptr, sizeof(buffer) - cur_len, ":%s", parv[parc-1]);
+
+  /* add a trailing \0 if it was too long */
+  if((cur_len + len) >= BUFSIZE)
+    buffer[BUFSIZE-1] = '\0';
+
+  sendto_match_cap_servs(NULL, cptr, CAP_ENCAP,
+                           ":%s ENCAP %s", parv[0], buffer);
+
+  return 0;
+}
